import bz2
import requests
import os

pkg = requests.get("http://apt.thebigboss.org/repofiles/cydia/dists/stable/main/binary-iphoneos-arm/Packages.bz2")
print("Got packages file!")
print("Compressed length: " + str(len(pkg.content)))
packages = bz2.decompress(pkg.content).decode('utf-8', 'ignore')
print("Uncompressed length: " + str(len(packages)))
lines = packages.splitlines()
for line in lines:
  if line.startswith("Filename:"):
    if os.path.isfile("./debs/" + line[10:len(line)]):
      print(line[10:] + " already saved, skipping...")
      continue
    print("Retrieving " + line[10:] + "...")
    r = requests.get("http://apt.thebigboss.org/repofiles/cydia/" + line[10:])
    if r.status_code != requests.codes.ok:
      print("Failed to get file with HTTP error code: " + str(r.status_code))
      continue
    if len(r.content) < 100:
      print("Got " + line[10:] + ", it does not contain a valid package.")
      continue
    print("Got " + line[10:] + ". Size: " + str(len(r.content)))
    try:
        os.makedirs("./debs/" + line[10:len(line)])
        os.rmdir("./debs/" + line[10:len(line)])
    except:
        print("Already exists.")
    out = open("./debs/" + line[10:len(line)], 'wb')
    out.write(r.content)
    out.close()
    print("Saved " + line[10:] + ".")
